/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.commons.jdt;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>JDT Java Classifier</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.emftext.commons.jdt.JDTJavaClassifier#getSimpleName <em>Simple Name</em>}</li>
 *   <li>{@link org.emftext.commons.jdt.JDTJavaClassifier#getPackageName <em>Package Name</em>}</li>
 *   <li>{@link org.emftext.commons.jdt.JDTJavaClassifier#getEnclosingTypeNames <em>Enclosing Type Names</em>}</li>
 *   <li>{@link org.emftext.commons.jdt.JDTJavaClassifier#getPath <em>Path</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.emftext.commons.jdt.JdtPackage#getJDTJavaClassifier()
 * @model
 * @generated
 */
public interface JDTJavaClassifier extends EObject
{
  /**
   * Returns the value of the '<em><b>Simple Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Simple Name</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Simple Name</em>' attribute.
   * @see #setSimpleName(String)
   * @see org.emftext.commons.jdt.JdtPackage#getJDTJavaClassifier_SimpleName()
   * @model required="true"
   * @generated
   */
  String getSimpleName();

  /**
   * Sets the value of the '{@link org.emftext.commons.jdt.JDTJavaClassifier#getSimpleName <em>Simple Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Simple Name</em>' attribute.
   * @see #getSimpleName()
   * @generated
   */
  void setSimpleName(String value);

  /**
   * Returns the value of the '<em><b>Package Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Package Name</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Package Name</em>' attribute.
   * @see #setPackageName(String)
   * @see org.emftext.commons.jdt.JdtPackage#getJDTJavaClassifier_PackageName()
   * @model required="true"
   * @generated
   */
  String getPackageName();

  /**
   * Sets the value of the '{@link org.emftext.commons.jdt.JDTJavaClassifier#getPackageName <em>Package Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Package Name</em>' attribute.
   * @see #getPackageName()
   * @generated
   */
  void setPackageName(String value);

  /**
   * Returns the value of the '<em><b>Enclosing Type Names</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Enclosing Type Names</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Enclosing Type Names</em>' attribute list.
   * @see org.emftext.commons.jdt.JdtPackage#getJDTJavaClassifier_EnclosingTypeNames()
   * @model
   * @generated
   */
  EList<String> getEnclosingTypeNames();

  /**
   * Returns the value of the '<em><b>Path</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Path</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Path</em>' attribute.
   * @see #setPath(String)
   * @see org.emftext.commons.jdt.JdtPackage#getJDTJavaClassifier_Path()
   * @model required="true"
   * @generated
   */
  String getPath();

  /**
   * Sets the value of the '{@link org.emftext.commons.jdt.JDTJavaClassifier#getPath <em>Path</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Path</em>' attribute.
   * @see #getPath()
   * @generated
   */
  void setPath(String value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   * <!-- end-model-doc -->
   * @model kind="operation" required="true"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='java.lang.StringBuilder qualifiedName = new java.lang.StringBuilder ();\r\nqualifiedName.append(getPackageName());\r\nqualifiedName.append(\".\");\r\nfor ( java.lang.String enclosingType:getEnclosingTypeNames()) {\r\n\tqualifiedName.append(enclosingType);\r\n\tqualifiedName.append(\"$\");\r\n}\r\nqualifiedName.append(getSimpleName());\r\nreturn qualifiedName.toString();\r\n'"
   * @generated
   */
  String getQualifiedName();

} // JDTJavaClassifier
