/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.commons.jdt;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.emftext.commons.jdt.JdtFactory
 * @model kind="package"
 * @generated
 */
public interface JdtPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "jdt";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://www.emftext.org/commons/jdt";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "jdt";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  JdtPackage eINSTANCE = org.emftext.commons.jdt.impl.JdtPackageImpl.init();

  /**
   * The meta object id for the '{@link org.emftext.commons.jdt.impl.JDTJavaClassifierImpl <em>JDT Java Classifier</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.emftext.commons.jdt.impl.JDTJavaClassifierImpl
   * @see org.emftext.commons.jdt.impl.JdtPackageImpl#getJDTJavaClassifier()
   * @generated
   */
  int JDT_JAVA_CLASSIFIER = 0;

  /**
   * The feature id for the '<em><b>Simple Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int JDT_JAVA_CLASSIFIER__SIMPLE_NAME = 0;

  /**
   * The feature id for the '<em><b>Package Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int JDT_JAVA_CLASSIFIER__PACKAGE_NAME = 1;

  /**
   * The feature id for the '<em><b>Enclosing Type Names</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int JDT_JAVA_CLASSIFIER__ENCLOSING_TYPE_NAMES = 2;

  /**
   * The feature id for the '<em><b>Path</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int JDT_JAVA_CLASSIFIER__PATH = 3;

  /**
   * The number of structural features of the '<em>JDT Java Classifier</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int JDT_JAVA_CLASSIFIER_FEATURE_COUNT = 4;


  /**
   * Returns the meta object for class '{@link org.emftext.commons.jdt.JDTJavaClassifier <em>JDT Java Classifier</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>JDT Java Classifier</em>'.
   * @see org.emftext.commons.jdt.JDTJavaClassifier
   * @generated
   */
  EClass getJDTJavaClassifier();

  /**
   * Returns the meta object for the attribute '{@link org.emftext.commons.jdt.JDTJavaClassifier#getSimpleName <em>Simple Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Simple Name</em>'.
   * @see org.emftext.commons.jdt.JDTJavaClassifier#getSimpleName()
   * @see #getJDTJavaClassifier()
   * @generated
   */
  EAttribute getJDTJavaClassifier_SimpleName();

  /**
   * Returns the meta object for the attribute '{@link org.emftext.commons.jdt.JDTJavaClassifier#getPackageName <em>Package Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Package Name</em>'.
   * @see org.emftext.commons.jdt.JDTJavaClassifier#getPackageName()
   * @see #getJDTJavaClassifier()
   * @generated
   */
  EAttribute getJDTJavaClassifier_PackageName();

  /**
   * Returns the meta object for the attribute list '{@link org.emftext.commons.jdt.JDTJavaClassifier#getEnclosingTypeNames <em>Enclosing Type Names</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Enclosing Type Names</em>'.
   * @see org.emftext.commons.jdt.JDTJavaClassifier#getEnclosingTypeNames()
   * @see #getJDTJavaClassifier()
   * @generated
   */
  EAttribute getJDTJavaClassifier_EnclosingTypeNames();

  /**
   * Returns the meta object for the attribute '{@link org.emftext.commons.jdt.JDTJavaClassifier#getPath <em>Path</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Path</em>'.
   * @see org.emftext.commons.jdt.JDTJavaClassifier#getPath()
   * @see #getJDTJavaClassifier()
   * @generated
   */
  EAttribute getJDTJavaClassifier_Path();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  JdtFactory getJdtFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link org.emftext.commons.jdt.impl.JDTJavaClassifierImpl <em>JDT Java Classifier</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.emftext.commons.jdt.impl.JDTJavaClassifierImpl
     * @see org.emftext.commons.jdt.impl.JdtPackageImpl#getJDTJavaClassifier()
     * @generated
     */
    EClass JDT_JAVA_CLASSIFIER = eINSTANCE.getJDTJavaClassifier();

    /**
     * The meta object literal for the '<em><b>Simple Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute JDT_JAVA_CLASSIFIER__SIMPLE_NAME = eINSTANCE.getJDTJavaClassifier_SimpleName();

    /**
     * The meta object literal for the '<em><b>Package Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute JDT_JAVA_CLASSIFIER__PACKAGE_NAME = eINSTANCE.getJDTJavaClassifier_PackageName();

    /**
     * The meta object literal for the '<em><b>Enclosing Type Names</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute JDT_JAVA_CLASSIFIER__ENCLOSING_TYPE_NAMES = eINSTANCE.getJDTJavaClassifier_EnclosingTypeNames();

    /**
     * The meta object literal for the '<em><b>Path</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute JDT_JAVA_CLASSIFIER__PATH = eINSTANCE.getJDTJavaClassifier_Path();

  }

} //JdtPackage
