/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.commons.jdt.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;

import org.emftext.commons.jdt.JDTJavaClassifier;
import org.emftext.commons.jdt.JdtPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>JDT Java Classifier</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.emftext.commons.jdt.impl.JDTJavaClassifierImpl#getSimpleName <em>Simple Name</em>}</li>
 *   <li>{@link org.emftext.commons.jdt.impl.JDTJavaClassifierImpl#getPackageName <em>Package Name</em>}</li>
 *   <li>{@link org.emftext.commons.jdt.impl.JDTJavaClassifierImpl#getEnclosingTypeNames <em>Enclosing Type Names</em>}</li>
 *   <li>{@link org.emftext.commons.jdt.impl.JDTJavaClassifierImpl#getPath <em>Path</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class JDTJavaClassifierImpl extends EObjectImpl implements JDTJavaClassifier
{
  /**
   * The default value of the '{@link #getSimpleName() <em>Simple Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSimpleName()
   * @generated
   * @ordered
   */
  protected static final String SIMPLE_NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getSimpleName() <em>Simple Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSimpleName()
   * @generated
   * @ordered
   */
  protected String simpleName = SIMPLE_NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getPackageName() <em>Package Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPackageName()
   * @generated
   * @ordered
   */
  protected static final String PACKAGE_NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getPackageName() <em>Package Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPackageName()
   * @generated
   * @ordered
   */
  protected String packageName = PACKAGE_NAME_EDEFAULT;

  /**
   * The cached value of the '{@link #getEnclosingTypeNames() <em>Enclosing Type Names</em>}' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEnclosingTypeNames()
   * @generated
   * @ordered
   */
  protected EList<String> enclosingTypeNames;

  /**
   * The default value of the '{@link #getPath() <em>Path</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPath()
   * @generated
   * @ordered
   */
  protected static final String PATH_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getPath() <em>Path</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPath()
   * @generated
   * @ordered
   */
  protected String path = PATH_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected JDTJavaClassifierImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return JdtPackage.Literals.JDT_JAVA_CLASSIFIER;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getSimpleName()
  {
    return simpleName;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSimpleName(String newSimpleName)
  {
    String oldSimpleName = simpleName;
    simpleName = newSimpleName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, JdtPackage.JDT_JAVA_CLASSIFIER__SIMPLE_NAME, oldSimpleName, simpleName));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getPackageName()
  {
    return packageName;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPackageName(String newPackageName)
  {
    String oldPackageName = packageName;
    packageName = newPackageName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, JdtPackage.JDT_JAVA_CLASSIFIER__PACKAGE_NAME, oldPackageName, packageName));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<String> getEnclosingTypeNames()
  {
    if (enclosingTypeNames == null)
    {
      enclosingTypeNames = new EDataTypeUniqueEList<String>(String.class, this, JdtPackage.JDT_JAVA_CLASSIFIER__ENCLOSING_TYPE_NAMES);
    }
    return enclosingTypeNames;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getPath()
  {
    return path;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPath(String newPath)
  {
    String oldPath = path;
    path = newPath;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, JdtPackage.JDT_JAVA_CLASSIFIER__PATH, oldPath, path));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getQualifiedName()
  {
    java.lang.StringBuilder qualifiedName = new java.lang.StringBuilder ();
    qualifiedName.append(getPackageName());
    qualifiedName.append(".");
    for ( java.lang.String enclosingType:getEnclosingTypeNames()) {
      qualifiedName.append(enclosingType);
      qualifiedName.append("$");
    }
    qualifiedName.append(getSimpleName());
    return qualifiedName.toString();
    
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case JdtPackage.JDT_JAVA_CLASSIFIER__SIMPLE_NAME:
        return getSimpleName();
      case JdtPackage.JDT_JAVA_CLASSIFIER__PACKAGE_NAME:
        return getPackageName();
      case JdtPackage.JDT_JAVA_CLASSIFIER__ENCLOSING_TYPE_NAMES:
        return getEnclosingTypeNames();
      case JdtPackage.JDT_JAVA_CLASSIFIER__PATH:
        return getPath();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case JdtPackage.JDT_JAVA_CLASSIFIER__SIMPLE_NAME:
        setSimpleName((String)newValue);
        return;
      case JdtPackage.JDT_JAVA_CLASSIFIER__PACKAGE_NAME:
        setPackageName((String)newValue);
        return;
      case JdtPackage.JDT_JAVA_CLASSIFIER__ENCLOSING_TYPE_NAMES:
        getEnclosingTypeNames().clear();
        getEnclosingTypeNames().addAll((Collection<? extends String>)newValue);
        return;
      case JdtPackage.JDT_JAVA_CLASSIFIER__PATH:
        setPath((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case JdtPackage.JDT_JAVA_CLASSIFIER__SIMPLE_NAME:
        setSimpleName(SIMPLE_NAME_EDEFAULT);
        return;
      case JdtPackage.JDT_JAVA_CLASSIFIER__PACKAGE_NAME:
        setPackageName(PACKAGE_NAME_EDEFAULT);
        return;
      case JdtPackage.JDT_JAVA_CLASSIFIER__ENCLOSING_TYPE_NAMES:
        getEnclosingTypeNames().clear();
        return;
      case JdtPackage.JDT_JAVA_CLASSIFIER__PATH:
        setPath(PATH_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case JdtPackage.JDT_JAVA_CLASSIFIER__SIMPLE_NAME:
        return SIMPLE_NAME_EDEFAULT == null ? simpleName != null : !SIMPLE_NAME_EDEFAULT.equals(simpleName);
      case JdtPackage.JDT_JAVA_CLASSIFIER__PACKAGE_NAME:
        return PACKAGE_NAME_EDEFAULT == null ? packageName != null : !PACKAGE_NAME_EDEFAULT.equals(packageName);
      case JdtPackage.JDT_JAVA_CLASSIFIER__ENCLOSING_TYPE_NAMES:
        return enclosingTypeNames != null && !enclosingTypeNames.isEmpty();
      case JdtPackage.JDT_JAVA_CLASSIFIER__PATH:
        return PATH_EDEFAULT == null ? path != null : !PATH_EDEFAULT.equals(path);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (simpleName: ");
    result.append(simpleName);
    result.append(", packageName: ");
    result.append(packageName);
    result.append(", enclosingTypeNames: ");
    result.append(enclosingTypeNames);
    result.append(", path: ");
    result.append(path);
    result.append(')');
    return result.toString();
  }

} //JDTJavaClassifierImpl
