/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.java.resource.java.grammar;

/**
 * A class to represent a rules in the grammar.
 */
public class JavaRule extends org.emftext.language.java.resource.java.grammar.JavaSyntaxElement {
	
	private final org.eclipse.emf.ecore.EClass metaclass;
	
	public JavaRule(org.eclipse.emf.ecore.EClass metaclass, org.emftext.language.java.resource.java.grammar.JavaChoice choice, org.emftext.language.java.resource.java.grammar.JavaCardinality cardinality) {
		super(cardinality, new org.emftext.language.java.resource.java.grammar.JavaSyntaxElement[] {choice});
		this.metaclass = metaclass;
	}
	
	public org.eclipse.emf.ecore.EClass getMetaclass() {
		return metaclass;
	}
	
	public org.emftext.language.java.resource.java.grammar.JavaChoice getDefinition() {
		return (org.emftext.language.java.resource.java.grammar.JavaChoice) getChildren()[0];
	}
	
}

