/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.java.resource.java.mopp;

public class JavaProblem implements org.emftext.language.java.resource.java.IJavaProblem {
	
	private String message;
	private org.emftext.language.java.resource.java.JavaEProblemType type;
	private org.emftext.language.java.resource.java.JavaEProblemSeverity severity;
	private java.util.Collection<org.emftext.language.java.resource.java.IJavaQuickFix> quickFixes;
	
	public JavaProblem(String message, org.emftext.language.java.resource.java.JavaEProblemType type, org.emftext.language.java.resource.java.JavaEProblemSeverity severity) {
		this(message, type, severity, java.util.Collections.<org.emftext.language.java.resource.java.IJavaQuickFix>emptySet());
	}
	
	public JavaProblem(String message, org.emftext.language.java.resource.java.JavaEProblemType type, org.emftext.language.java.resource.java.JavaEProblemSeverity severity, org.emftext.language.java.resource.java.IJavaQuickFix quickFix) {
		this(message, type, severity, java.util.Collections.singleton(quickFix));
	}
	
	public JavaProblem(String message, org.emftext.language.java.resource.java.JavaEProblemType type, org.emftext.language.java.resource.java.JavaEProblemSeverity severity, java.util.Collection<org.emftext.language.java.resource.java.IJavaQuickFix> quickFixes) {
		super();
		this.message = message;
		this.type = type;
		this.severity = severity;
		this.quickFixes = new java.util.LinkedHashSet<org.emftext.language.java.resource.java.IJavaQuickFix>();
		this.quickFixes.addAll(quickFixes);
	}
	
	public org.emftext.language.java.resource.java.JavaEProblemType getType() {
		return type;
	}
	
	public org.emftext.language.java.resource.java.JavaEProblemSeverity getSeverity() {
		return severity;
	}
	
	public String getMessage() {
		return message;
	}
	
	public java.util.Collection<org.emftext.language.java.resource.java.IJavaQuickFix> getQuickFixes() {
		return quickFixes;
	}
	
}
